diff --git a/src/backend/snowball/libstemmer/stem_ISO_8859_1_finnish.c b/src/backend/snowball/libstemmer/stem_ISO_8859_1_finnish.c
index 9621771d28..58285e8c34 100644
--- a/src/backend/snowball/libstemmer/stem_ISO_8859_1_finnish.c
+++ b/src/backend/snowball/libstemmer/stem_ISO_8859_1_finnish.c
@@ -1,5 +1,5 @@
-
-/* This file was generated automatically by the Snowball to ANSI C compiler */
+/* This file was generated automatically by the Snowball to ISO C compiler */
+/* http://snowballstem.org/ */
 
 #include "header.h"
 
@@ -183,7 +183,7 @@ static const struct among a_6[30] =
 /*  4 */ { 2, s_6_4, 0, -1, 0},
 /*  5 */ { 3, s_6_5, 4, -1, 0},
 /*  6 */ { 3, s_6_6, 4, -1, 0},
-/*  7 */ { 3, s_6_7, 4, 9, 0},
+/*  7 */ { 3, s_6_7, 4, 2, 0},
 /*  8 */ { 3, s_6_8, -1, -1, 0},
 /*  9 */ { 3, s_6_9, -1, -1, 0},
 /* 10 */ { 3, s_6_10, -1, -1, 0},
@@ -205,7 +205,7 @@ static const struct among a_6[30] =
 /* 26 */ { 2, s_6_26, 22, -1, 0},
 /* 27 */ { 3, s_6_27, 26, -1, 0},
 /* 28 */ { 3, s_6_28, 26, -1, 0},
-/* 29 */ { 3, s_6_29, 26, 9, 0}
+/* 29 */ { 3, s_6_29, 26, 2, 0}
 };
 
 static const symbol s_7_0[3] = { 'e', 'j', 'a' };
@@ -261,151 +261,132 @@ static const struct among a_9[2] =
 
 static const unsigned char g_AEI[] = { 17, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8 };
 
+static const unsigned char g_C[] = { 119, 223, 119, 1 };
+
 static const unsigned char g_V1[] = { 17, 65, 16, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 0, 32 };
 
 static const unsigned char g_V2[] = { 17, 65, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 0, 32 };
 
 static const unsigned char g_particle_end[] = { 17, 97, 24, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 0, 32 };
 
-static const symbol s_0[] = { 'k' };
-static const symbol s_1[] = { 'k', 's', 'e' };
-static const symbol s_2[] = { 'k', 's', 'i' };
-static const symbol s_3[] = { 'i' };
-static const symbol s_4[] = { 'a' };
-static const symbol s_5[] = { 'e' };
-static const symbol s_6[] = { 'i' };
-static const symbol s_7[] = { 'o' };
-static const symbol s_8[] = { 0xE4 };
-static const symbol s_9[] = { 0xF6 };
-static const symbol s_10[] = { 'i', 'e' };
-static const symbol s_11[] = { 'e' };
-static const symbol s_12[] = { 'p', 'o' };
-static const symbol s_13[] = { 't' };
-static const symbol s_14[] = { 'p', 'o' };
-static const symbol s_15[] = { 'j' };
-static const symbol s_16[] = { 'o' };
-static const symbol s_17[] = { 'u' };
-static const symbol s_18[] = { 'o' };
-static const symbol s_19[] = { 'j' };
+static const symbol s_0[] = { 'k', 's', 'e' };
+static const symbol s_1[] = { 'k', 's', 'i' };
+static const symbol s_2[] = { 'i', 'e' };
+static const symbol s_3[] = { 'p', 'o' };
+static const symbol s_4[] = { 'p', 'o' };
 
-static int r_mark_regions(struct SN_env * z) {
-    z->I[0] = z->l;
-    z->I[1] = z->l;
-    if (out_grouping(z, g_V1, 97, 246, 1) < 0) return 0; /* goto */ /* grouping V1, line 46 */
-    {    /* gopast */ /* non V1, line 46 */
-        int ret = in_grouping(z, g_V1, 97, 246, 1);
-        if (ret < 0) return 0;
-        z->c += ret;
-    }
-    z->I[0] = z->c; /* setmark p1, line 46 */
+static int r_mark_regions(struct SN_env * z) { /* forwardmode */
+    z->I[0] = z->l; /* $p1 = <integer expression>, line 44 */
+    z->I[1] = z->l; /* $p2 = <integer expression>, line 45 */
     if (out_grouping(z, g_V1, 97, 246, 1) < 0) return 0; /* goto */ /* grouping V1, line 47 */
     {    /* gopast */ /* non V1, line 47 */
         int ret = in_grouping(z, g_V1, 97, 246, 1);
         if (ret < 0) return 0;
         z->c += ret;
     }
-    z->I[1] = z->c; /* setmark p2, line 47 */
+    z->I[0] = z->c; /* setmark p1, line 47 */
+    if (out_grouping(z, g_V1, 97, 246, 1) < 0) return 0; /* goto */ /* grouping V1, line 48 */
+    {    /* gopast */ /* non V1, line 48 */
+        int ret = in_grouping(z, g_V1, 97, 246, 1);
+        if (ret < 0) return 0;
+        z->c += ret;
+    }
+    z->I[1] = z->c; /* setmark p2, line 48 */
     return 1;
 }
 
-static int r_R2(struct SN_env * z) {
-    if (!(z->I[1] <= z->c)) return 0;
+static int r_R2(struct SN_env * z) { /* backwardmode */
+    if (!(z->I[1] <= z->c)) return 0; /* $(<integer expression> <= <integer expression>), line 53 */
     return 1;
 }
 
-static int r_particle_etc(struct SN_env * z) {
+static int r_particle_etc(struct SN_env * z) { /* backwardmode */
     int among_var;
-    {   int mlimit; /* setlimit, line 55 */
-        int m1 = z->l - z->c; (void)m1;
+
+    {   int mlimit1; /* setlimit, line 56 */
         if (z->c < z->I[0]) return 0;
-        z->c = z->I[0]; /* tomark, line 55 */
-        mlimit = z->lb; z->lb = z->c;
-        z->c = z->l - m1;
-        z->ket = z->c; /* [, line 55 */
-        among_var = find_among_b(z, a_0, 10); /* substring, line 55 */
-        if (!(among_var)) { z->lb = mlimit; return 0; }
-        z->bra = z->c; /* ], line 55 */
-        z->lb = mlimit;
+        mlimit1 = z->lb; z->lb = z->I[0];
+        z->ket = z->c; /* [, line 56 */
+        among_var = find_among_b(z, a_0, 10); /* substring, line 56 */
+        if (!(among_var)) { z->lb = mlimit1; return 0; }
+        z->bra = z->c; /* ], line 56 */
+        z->lb = mlimit1;
     }
-    switch(among_var) {
-        case 0: return 0;
+    switch (among_var) { /* among, line 57 */
         case 1:
-            if (in_grouping_b(z, g_particle_end, 97, 246, 0)) return 0;
+            if (in_grouping_b(z, g_particle_end, 97, 246, 0)) return 0; /* grouping particle_end, line 63 */
             break;
         case 2:
-            {   int ret = r_R2(z);
-                if (ret == 0) return 0; /* call R2, line 64 */
-                if (ret < 0) return ret;
+            {   int ret = r_R2(z); /* call R2, line 65 */
+                if (ret <= 0) return ret;
             }
             break;
     }
-    {   int ret = slice_del(z); /* delete, line 66 */
+    {   int ret = slice_del(z); /* delete, line 67 */
         if (ret < 0) return ret;
     }
     return 1;
 }
 
-static int r_possessive(struct SN_env * z) {
+static int r_possessive(struct SN_env * z) { /* backwardmode */
     int among_var;
-    {   int mlimit; /* setlimit, line 69 */
-        int m1 = z->l - z->c; (void)m1;
+
+    {   int mlimit1; /* setlimit, line 70 */
         if (z->c < z->I[0]) return 0;
-        z->c = z->I[0]; /* tomark, line 69 */
-        mlimit = z->lb; z->lb = z->c;
-        z->c = z->l - m1;
-        z->ket = z->c; /* [, line 69 */
-        among_var = find_among_b(z, a_4, 9); /* substring, line 69 */
-        if (!(among_var)) { z->lb = mlimit; return 0; }
-        z->bra = z->c; /* ], line 69 */
-        z->lb = mlimit;
+        mlimit1 = z->lb; z->lb = z->I[0];
+        z->ket = z->c; /* [, line 70 */
+        among_var = find_among_b(z, a_4, 9); /* substring, line 70 */
+        if (!(among_var)) { z->lb = mlimit1; return 0; }
+        z->bra = z->c; /* ], line 70 */
+        z->lb = mlimit1;
     }
-    switch(among_var) {
-        case 0: return 0;
+    switch (among_var) { /* among, line 71 */
         case 1:
-            {   int m2 = z->l - z->c; (void)m2; /* not, line 72 */
-                if (!(eq_s_b(z, 1, s_0))) goto lab0;
+            {   int m2 = z->l - z->c; (void)m2; /* not, line 73 */
+                if (z->c <= z->lb || z->p[z->c - 1] != 'k') goto lab0; /* literal, line 73 */
+                z->c--;
                 return 0;
             lab0:
                 z->c = z->l - m2;
             }
-            {   int ret = slice_del(z); /* delete, line 72 */
+            {   int ret = slice_del(z); /* delete, line 73 */
                 if (ret < 0) return ret;
             }
             break;
         case 2:
-            {   int ret = slice_del(z); /* delete, line 74 */
+            {   int ret = slice_del(z); /* delete, line 75 */
                 if (ret < 0) return ret;
             }
-            z->ket = z->c; /* [, line 74 */
-            if (!(eq_s_b(z, 3, s_1))) return 0;
-            z->bra = z->c; /* ], line 74 */
-            {   int ret = slice_from_s(z, 3, s_2); /* <-, line 74 */
+            z->ket = z->c; /* [, line 75 */
+            if (!(eq_s_b(z, 3, s_0))) return 0; /* literal, line 75 */
+            z->bra = z->c; /* ], line 75 */
+            {   int ret = slice_from_s(z, 3, s_1); /* <-, line 75 */
                 if (ret < 0) return ret;
             }
             break;
         case 3:
-            {   int ret = slice_del(z); /* delete, line 78 */
+            {   int ret = slice_del(z); /* delete, line 79 */
                 if (ret < 0) return ret;
             }
             break;
         case 4:
-            if (z->c - 1 <= z->lb || z->p[z->c - 1] != 97) return 0;
-            if (!(find_among_b(z, a_1, 6))) return 0; /* among, line 81 */
-            {   int ret = slice_del(z); /* delete, line 81 */
+            if (z->c - 1 <= z->lb || z->p[z->c - 1] != 97) return 0; /* among, line 82 */
+            if (!(find_among_b(z, a_1, 6))) return 0;
+            {   int ret = slice_del(z); /* delete, line 82 */
                 if (ret < 0) return ret;
             }
             break;
         case 5:
-            if (z->c - 1 <= z->lb || z->p[z->c - 1] != 228) return 0;
-            if (!(find_among_b(z, a_2, 6))) return 0; /* among, line 83 */
-            {   int ret = slice_del(z); /* delete, line 84 */
+            if (z->c - 1 <= z->lb || z->p[z->c - 1] != 228) return 0; /* among, line 84 */
+            if (!(find_among_b(z, a_2, 6))) return 0;
+            {   int ret = slice_del(z); /* delete, line 85 */
                 if (ret < 0) return ret;
             }
             break;
         case 6:
-            if (z->c - 2 <= z->lb || z->p[z->c - 1] != 101) return 0;
-            if (!(find_among_b(z, a_3, 2))) return 0; /* among, line 86 */
-            {   int ret = slice_del(z); /* delete, line 86 */
+            if (z->c - 2 <= z->lb || z->p[z->c - 1] != 101) return 0; /* among, line 87 */
+            if (!(find_among_b(z, a_3, 2))) return 0;
+            {   int ret = slice_del(z); /* delete, line 87 */
                 if (ret < 0) return ret;
             }
             break;
@@ -413,344 +394,336 @@ static int r_possessive(struct SN_env * z) {
     return 1;
 }
 
-static int r_LONG(struct SN_env * z) {
-    if (!(find_among_b(z, a_5, 7))) return 0; /* among, line 91 */
+static int r_LONG(struct SN_env * z) { /* backwardmode */
+    if (!(find_among_b(z, a_5, 7))) return 0; /* among, line 92 */
     return 1;
 }
 
-static int r_VI(struct SN_env * z) {
-    if (!(eq_s_b(z, 1, s_3))) return 0;
-    if (in_grouping_b(z, g_V2, 97, 246, 0)) return 0;
+static int r_VI(struct SN_env * z) { /* backwardmode */
+    if (z->c <= z->lb || z->p[z->c - 1] != 'i') return 0; /* literal, line 94 */
+    z->c--;
+    if (in_grouping_b(z, g_V2, 97, 246, 0)) return 0; /* grouping V2, line 94 */
     return 1;
 }
 
-static int r_case_ending(struct SN_env * z) {
+static int r_case_ending(struct SN_env * z) { /* backwardmode */
     int among_var;
-    {   int mlimit; /* setlimit, line 96 */
-        int m1 = z->l - z->c; (void)m1;
+
+    {   int mlimit1; /* setlimit, line 97 */
         if (z->c < z->I[0]) return 0;
-        z->c = z->I[0]; /* tomark, line 96 */
-        mlimit = z->lb; z->lb = z->c;
-        z->c = z->l - m1;
-        z->ket = z->c; /* [, line 96 */
-        among_var = find_among_b(z, a_6, 30); /* substring, line 96 */
-        if (!(among_var)) { z->lb = mlimit; return 0; }
-        z->bra = z->c; /* ], line 96 */
-        z->lb = mlimit;
+        mlimit1 = z->lb; z->lb = z->I[0];
+        z->ket = z->c; /* [, line 97 */
+        among_var = find_among_b(z, a_6, 30); /* substring, line 97 */
+        if (!(among_var)) { z->lb = mlimit1; return 0; }
+        z->bra = z->c; /* ], line 97 */
+        z->lb = mlimit1;
     }
-    switch(among_var) {
-        case 0: return 0;
+    switch (among_var) { /* among, line 98 */
         case 1:
-            if (!(eq_s_b(z, 1, s_4))) return 0;
+            if (z->c <= z->lb || z->p[z->c - 1] != 'a') return 0; /* literal, line 99 */
+            z->c--;
             break;
         case 2:
-            if (!(eq_s_b(z, 1, s_5))) return 0;
+            if (z->c <= z->lb || z->p[z->c - 1] != 'e') return 0; /* literal, line 100 */
+            z->c--;
             break;
         case 3:
-            if (!(eq_s_b(z, 1, s_6))) return 0;
+            if (z->c <= z->lb || z->p[z->c - 1] != 'i') return 0; /* literal, line 101 */
+            z->c--;
             break;
         case 4:
-            if (!(eq_s_b(z, 1, s_7))) return 0;
+            if (z->c <= z->lb || z->p[z->c - 1] != 'o') return 0; /* literal, line 102 */
+            z->c--;
             break;
         case 5:
-            if (!(eq_s_b(z, 1, s_8))) return 0;
+            if (z->c <= z->lb || z->p[z->c - 1] != 0xE4) return 0; /* literal, line 103 */
+            z->c--;
             break;
         case 6:
-            if (!(eq_s_b(z, 1, s_9))) return 0;
+            if (z->c <= z->lb || z->p[z->c - 1] != 0xF6) return 0; /* literal, line 104 */
+            z->c--;
             break;
         case 7:
-            {   int m_keep = z->l - z->c;/* (void) m_keep;*/ /* try, line 111 */
-                {   int m2 = z->l - z->c; (void)m2; /* and, line 113 */
-                    {   int m3 = z->l - z->c; (void)m3; /* or, line 112 */
-                        {   int ret = r_LONG(z);
-                            if (ret == 0) goto lab2; /* call LONG, line 111 */
+            {   int m2 = z->l - z->c; (void)m2; /* try, line 112 */
+                {   int m3 = z->l - z->c; (void)m3; /* and, line 114 */
+                    {   int m4 = z->l - z->c; (void)m4; /* or, line 113 */
+                        {   int ret = r_LONG(z); /* call LONG, line 112 */
+                            if (ret == 0) goto lab2;
                             if (ret < 0) return ret;
                         }
                         goto lab1;
                     lab2:
-                        z->c = z->l - m3;
-                        if (!(eq_s_b(z, 2, s_10))) { z->c = z->l - m_keep; goto lab0; }
+                        z->c = z->l - m4;
+                        if (!(eq_s_b(z, 2, s_2))) { z->c = z->l - m2; goto lab0; } /* literal, line 113 */
                     }
                 lab1:
-                    z->c = z->l - m2;
-                    if (z->c <= z->lb) { z->c = z->l - m_keep; goto lab0; }
-                    z->c--; /* next, line 113 */
+                    z->c = z->l - m3;
+                    if (z->c <= z->lb) { z->c = z->l - m2; goto lab0; }
+                    z->c--; /* next, line 114 */
                 }
-                z->bra = z->c; /* ], line 113 */
+                z->bra = z->c; /* ], line 114 */
             lab0:
                 ;
             }
             break;
         case 8:
-            if (in_grouping_b(z, g_V1, 97, 246, 0)) return 0;
-            if (out_grouping_b(z, g_V1, 97, 246, 0)) return 0;
-            break;
-        case 9:
-            if (!(eq_s_b(z, 1, s_11))) return 0;
+            if (in_grouping_b(z, g_V1, 97, 246, 0)) return 0; /* grouping V1, line 120 */
+            if (in_grouping_b(z, g_C, 98, 122, 0)) return 0; /* grouping C, line 120 */
             break;
     }
-    {   int ret = slice_del(z); /* delete, line 138 */
+    {   int ret = slice_del(z); /* delete, line 139 */
         if (ret < 0) return ret;
     }
-    z->B[0] = 1; /* set ending_removed, line 139 */
+    z->B[0] = 1; /* set ending_removed, line 140 */
     return 1;
 }
 
-static int r_other_endings(struct SN_env * z) {
+static int r_other_endings(struct SN_env * z) { /* backwardmode */
     int among_var;
-    {   int mlimit; /* setlimit, line 142 */
-        int m1 = z->l - z->c; (void)m1;
+
+    {   int mlimit1; /* setlimit, line 143 */
         if (z->c < z->I[1]) return 0;
-        z->c = z->I[1]; /* tomark, line 142 */
-        mlimit = z->lb; z->lb = z->c;
-        z->c = z->l - m1;
-        z->ket = z->c; /* [, line 142 */
-        among_var = find_among_b(z, a_7, 14); /* substring, line 142 */
-        if (!(among_var)) { z->lb = mlimit; return 0; }
-        z->bra = z->c; /* ], line 142 */
-        z->lb = mlimit;
+        mlimit1 = z->lb; z->lb = z->I[1];
+        z->ket = z->c; /* [, line 143 */
+        among_var = find_among_b(z, a_7, 14); /* substring, line 143 */
+        if (!(among_var)) { z->lb = mlimit1; return 0; }
+        z->bra = z->c; /* ], line 143 */
+        z->lb = mlimit1;
     }
-    switch(among_var) {
-        case 0: return 0;
+    switch (among_var) { /* among, line 144 */
         case 1:
-            {   int m2 = z->l - z->c; (void)m2; /* not, line 146 */
-                if (!(eq_s_b(z, 2, s_12))) goto lab0;
+            {   int m2 = z->l - z->c; (void)m2; /* not, line 147 */
+                if (!(eq_s_b(z, 2, s_3))) goto lab0; /* literal, line 147 */
                 return 0;
             lab0:
                 z->c = z->l - m2;
             }
             break;
     }
-    {   int ret = slice_del(z); /* delete, line 151 */
+    {   int ret = slice_del(z); /* delete, line 152 */
         if (ret < 0) return ret;
     }
     return 1;
 }
 
-static int r_i_plural(struct SN_env * z) {
-    {   int mlimit; /* setlimit, line 154 */
-        int m1 = z->l - z->c; (void)m1;
+static int r_i_plural(struct SN_env * z) { /* backwardmode */
+
+    {   int mlimit1; /* setlimit, line 155 */
         if (z->c < z->I[0]) return 0;
-        z->c = z->I[0]; /* tomark, line 154 */
-        mlimit = z->lb; z->lb = z->c;
-        z->c = z->l - m1;
-        z->ket = z->c; /* [, line 154 */
-        if (z->c <= z->lb || (z->p[z->c - 1] != 105 && z->p[z->c - 1] != 106)) { z->lb = mlimit; return 0; }
-        if (!(find_among_b(z, a_8, 2))) { z->lb = mlimit; return 0; } /* substring, line 154 */
-        z->bra = z->c; /* ], line 154 */
-        z->lb = mlimit;
+        mlimit1 = z->lb; z->lb = z->I[0];
+        z->ket = z->c; /* [, line 155 */
+        if (z->c <= z->lb || (z->p[z->c - 1] != 105 && z->p[z->c - 1] != 106)) { z->lb = mlimit1; return 0; } /* substring, line 155 */
+        if (!(find_among_b(z, a_8, 2))) { z->lb = mlimit1; return 0; }
+        z->bra = z->c; /* ], line 155 */
+        z->lb = mlimit1;
     }
-    {   int ret = slice_del(z); /* delete, line 158 */
+    {   int ret = slice_del(z); /* delete, line 159 */
         if (ret < 0) return ret;
     }
     return 1;
 }
 
-static int r_t_plural(struct SN_env * z) {
+static int r_t_plural(struct SN_env * z) { /* backwardmode */
     int among_var;
-    {   int mlimit; /* setlimit, line 161 */
-        int m1 = z->l - z->c; (void)m1;
+
+    {   int mlimit1; /* setlimit, line 162 */
         if (z->c < z->I[0]) return 0;
-        z->c = z->I[0]; /* tomark, line 161 */
-        mlimit = z->lb; z->lb = z->c;
-        z->c = z->l - m1;
-        z->ket = z->c; /* [, line 162 */
-        if (!(eq_s_b(z, 1, s_13))) { z->lb = mlimit; return 0; }
-        z->bra = z->c; /* ], line 162 */
-        {   int m_test = z->l - z->c; /* test, line 162 */
-            if (in_grouping_b(z, g_V1, 97, 246, 0)) { z->lb = mlimit; return 0; }
-            z->c = z->l - m_test;
+        mlimit1 = z->lb; z->lb = z->I[0];
+        z->ket = z->c; /* [, line 163 */
+        if (z->c <= z->lb || z->p[z->c - 1] != 't') { z->lb = mlimit1; return 0; } /* literal, line 163 */
+        z->c--;
+        z->bra = z->c; /* ], line 163 */
+        {   int m_test2 = z->l - z->c; /* test, line 163 */
+            if (in_grouping_b(z, g_V1, 97, 246, 0)) { z->lb = mlimit1; return 0; } /* grouping V1, line 163 */
+            z->c = z->l - m_test2;
         }
-        {   int ret = slice_del(z); /* delete, line 163 */
+        {   int ret = slice_del(z); /* delete, line 164 */
             if (ret < 0) return ret;
         }
-        z->lb = mlimit;
+        z->lb = mlimit1;
     }
-    {   int mlimit; /* setlimit, line 165 */
-        int m2 = z->l - z->c; (void)m2;
+
+    {   int mlimit3; /* setlimit, line 166 */
         if (z->c < z->I[1]) return 0;
-        z->c = z->I[1]; /* tomark, line 165 */
-        mlimit = z->lb; z->lb = z->c;
-        z->c = z->l - m2;
-        z->ket = z->c; /* [, line 165 */
-        if (z->c - 2 <= z->lb || z->p[z->c - 1] != 97) { z->lb = mlimit; return 0; }
-        among_var = find_among_b(z, a_9, 2); /* substring, line 165 */
-        if (!(among_var)) { z->lb = mlimit; return 0; }
-        z->bra = z->c; /* ], line 165 */
-        z->lb = mlimit;
+        mlimit3 = z->lb; z->lb = z->I[1];
+        z->ket = z->c; /* [, line 166 */
+        if (z->c - 2 <= z->lb || z->p[z->c - 1] != 97) { z->lb = mlimit3; return 0; } /* substring, line 166 */
+        among_var = find_among_b(z, a_9, 2);
+        if (!(among_var)) { z->lb = mlimit3; return 0; }
+        z->bra = z->c; /* ], line 166 */
+        z->lb = mlimit3;
     }
-    switch(among_var) {
-        case 0: return 0;
+    switch (among_var) { /* among, line 167 */
         case 1:
-            {   int m3 = z->l - z->c; (void)m3; /* not, line 167 */
-                if (!(eq_s_b(z, 2, s_14))) goto lab0;
+            {   int m4 = z->l - z->c; (void)m4; /* not, line 168 */
+                if (!(eq_s_b(z, 2, s_4))) goto lab0; /* literal, line 168 */
                 return 0;
             lab0:
-                z->c = z->l - m3;
+                z->c = z->l - m4;
             }
             break;
     }
-    {   int ret = slice_del(z); /* delete, line 170 */
+    {   int ret = slice_del(z); /* delete, line 171 */
         if (ret < 0) return ret;
     }
     return 1;
 }
 
-static int r_tidy(struct SN_env * z) {
-    {   int mlimit; /* setlimit, line 173 */
-        int m1 = z->l - z->c; (void)m1;
+static int r_tidy(struct SN_env * z) { /* backwardmode */
+
+    {   int mlimit1; /* setlimit, line 174 */
         if (z->c < z->I[0]) return 0;
-        z->c = z->I[0]; /* tomark, line 173 */
-        mlimit = z->lb; z->lb = z->c;
-        z->c = z->l - m1;
-        {   int m2 = z->l - z->c; (void)m2; /* do, line 174 */
-            {   int m3 = z->l - z->c; (void)m3; /* and, line 174 */
-                {   int ret = r_LONG(z);
-                    if (ret == 0) goto lab0; /* call LONG, line 174 */
+        mlimit1 = z->lb; z->lb = z->I[0];
+        {   int m2 = z->l - z->c; (void)m2; /* do, line 175 */
+            {   int m3 = z->l - z->c; (void)m3; /* and, line 175 */
+                {   int ret = r_LONG(z); /* call LONG, line 175 */
+                    if (ret == 0) goto lab0;
                     if (ret < 0) return ret;
                 }
                 z->c = z->l - m3;
-                z->ket = z->c; /* [, line 174 */
+                z->ket = z->c; /* [, line 175 */
                 if (z->c <= z->lb) goto lab0;
-                z->c--; /* next, line 174 */
-                z->bra = z->c; /* ], line 174 */
-                {   int ret = slice_del(z); /* delete, line 174 */
+                z->c--; /* next, line 175 */
+                z->bra = z->c; /* ], line 175 */
+                {   int ret = slice_del(z); /* delete, line 175 */
                     if (ret < 0) return ret;
                 }
             }
         lab0:
             z->c = z->l - m2;
         }
-        {   int m4 = z->l - z->c; (void)m4; /* do, line 175 */
-            z->ket = z->c; /* [, line 175 */
-            if (in_grouping_b(z, g_AEI, 97, 228, 0)) goto lab1;
-            z->bra = z->c; /* ], line 175 */
-            if (out_grouping_b(z, g_V1, 97, 246, 0)) goto lab1;
-            {   int ret = slice_del(z); /* delete, line 175 */
-                if (ret < 0) return ret;
-            }
-        lab1:
-            z->c = z->l - m4;
-        }
-        {   int m5 = z->l - z->c; (void)m5; /* do, line 176 */
+        {   int m4 = z->l - z->c; (void)m4; /* do, line 176 */
             z->ket = z->c; /* [, line 176 */
-            if (!(eq_s_b(z, 1, s_15))) goto lab2;
+            if (in_grouping_b(z, g_AEI, 97, 228, 0)) goto lab1; /* grouping AEI, line 176 */
             z->bra = z->c; /* ], line 176 */
-            {   int m6 = z->l - z->c; (void)m6; /* or, line 176 */
-                if (!(eq_s_b(z, 1, s_16))) goto lab4;
+            if (in_grouping_b(z, g_C, 98, 122, 0)) goto lab1; /* grouping C, line 176 */
+            {   int ret = slice_del(z); /* delete, line 176 */
+                if (ret < 0) return ret;
+            }
+        lab1:
+            z->c = z->l - m4;
+        }
+        {   int m5 = z->l - z->c; (void)m5; /* do, line 177 */
+            z->ket = z->c; /* [, line 177 */
+            if (z->c <= z->lb || z->p[z->c - 1] != 'j') goto lab2; /* literal, line 177 */
+            z->c--;
+            z->bra = z->c; /* ], line 177 */
+            {   int m6 = z->l - z->c; (void)m6; /* or, line 177 */
+                if (z->c <= z->lb || z->p[z->c - 1] != 'o') goto lab4; /* literal, line 177 */
+                z->c--;
                 goto lab3;
             lab4:
                 z->c = z->l - m6;
-                if (!(eq_s_b(z, 1, s_17))) goto lab2;
+                if (z->c <= z->lb || z->p[z->c - 1] != 'u') goto lab2; /* literal, line 177 */
+                z->c--;
             }
         lab3:
-            {   int ret = slice_del(z); /* delete, line 176 */
+            {   int ret = slice_del(z); /* delete, line 177 */
                 if (ret < 0) return ret;
             }
         lab2:
             z->c = z->l - m5;
         }
-        {   int m7 = z->l - z->c; (void)m7; /* do, line 177 */
-            z->ket = z->c; /* [, line 177 */
-            if (!(eq_s_b(z, 1, s_18))) goto lab5;
-            z->bra = z->c; /* ], line 177 */
-            if (!(eq_s_b(z, 1, s_19))) goto lab5;
-            {   int ret = slice_del(z); /* delete, line 177 */
+        {   int m7 = z->l - z->c; (void)m7; /* do, line 178 */
+            z->ket = z->c; /* [, line 178 */
+            if (z->c <= z->lb || z->p[z->c - 1] != 'o') goto lab5; /* literal, line 178 */
+            z->c--;
+            z->bra = z->c; /* ], line 178 */
+            if (z->c <= z->lb || z->p[z->c - 1] != 'j') goto lab5; /* literal, line 178 */
+            z->c--;
+            {   int ret = slice_del(z); /* delete, line 178 */
                 if (ret < 0) return ret;
             }
         lab5:
             z->c = z->l - m7;
         }
-        z->lb = mlimit;
+        z->lb = mlimit1;
     }
-    if (in_grouping_b(z, g_V1, 97, 246, 1) < 0) return 0; /* goto */ /* non V1, line 179 */
-    z->ket = z->c; /* [, line 179 */
-    if (z->c <= z->lb) return 0;
-    z->c--; /* next, line 179 */
-    z->bra = z->c; /* ], line 179 */
-    z->S[0] = slice_to(z, z->S[0]); /* -> x, line 179 */
-    if (z->S[0] == 0) return -1; /* -> x, line 179 */
-    if (!(eq_v_b(z, z->S[0]))) return 0; /* name x, line 179 */
-    {   int ret = slice_del(z); /* delete, line 179 */
+    if (in_grouping_b(z, g_V1, 97, 246, 1) < 0) return 0; /* goto */ /* non V1, line 180 */
+    z->ket = z->c; /* [, line 180 */
+    if (in_grouping_b(z, g_C, 98, 122, 0)) return 0; /* grouping C, line 180 */
+    z->bra = z->c; /* ], line 180 */
+    z->S[0] = slice_to(z, z->S[0]); /* -> x, line 180 */
+    if (z->S[0] == 0) return -1; /* -> x, line 180 */
+    if (!(eq_v_b(z, z->S[0]))) return 0; /* name x, line 180 */
+    {   int ret = slice_del(z); /* delete, line 180 */
         if (ret < 0) return ret;
     }
     return 1;
 }
 
-extern int finnish_ISO_8859_1_stem(struct SN_env * z) {
-    {   int c1 = z->c; /* do, line 185 */
-        {   int ret = r_mark_regions(z);
-            if (ret == 0) goto lab0; /* call mark_regions, line 185 */
+extern int finnish_ISO_8859_1_stem(struct SN_env * z) { /* forwardmode */
+    {   int c1 = z->c; /* do, line 186 */
+        {   int ret = r_mark_regions(z); /* call mark_regions, line 186 */
+            if (ret == 0) goto lab0;
             if (ret < 0) return ret;
         }
     lab0:
         z->c = c1;
     }
-    z->B[0] = 0; /* unset ending_removed, line 186 */
-    z->lb = z->c; z->c = z->l; /* backwards, line 187 */
+    z->B[0] = 0; /* unset ending_removed, line 187 */
+    z->lb = z->c; z->c = z->l; /* backwards, line 188 */
 
-    {   int m2 = z->l - z->c; (void)m2; /* do, line 188 */
-        {   int ret = r_particle_etc(z);
-            if (ret == 0) goto lab1; /* call particle_etc, line 188 */
+    {   int m2 = z->l - z->c; (void)m2; /* do, line 189 */
+        {   int ret = r_particle_etc(z); /* call particle_etc, line 189 */
+            if (ret == 0) goto lab1;
             if (ret < 0) return ret;
         }
     lab1:
         z->c = z->l - m2;
     }
-    {   int m3 = z->l - z->c; (void)m3; /* do, line 189 */
-        {   int ret = r_possessive(z);
-            if (ret == 0) goto lab2; /* call possessive, line 189 */
+    {   int m3 = z->l - z->c; (void)m3; /* do, line 190 */
+        {   int ret = r_possessive(z); /* call possessive, line 190 */
+            if (ret == 0) goto lab2;
             if (ret < 0) return ret;
         }
     lab2:
         z->c = z->l - m3;
     }
-    {   int m4 = z->l - z->c; (void)m4; /* do, line 190 */
-        {   int ret = r_case_ending(z);
-            if (ret == 0) goto lab3; /* call case_ending, line 190 */
+    {   int m4 = z->l - z->c; (void)m4; /* do, line 191 */
+        {   int ret = r_case_ending(z); /* call case_ending, line 191 */
+            if (ret == 0) goto lab3;
             if (ret < 0) return ret;
         }
     lab3:
         z->c = z->l - m4;
     }
-    {   int m5 = z->l - z->c; (void)m5; /* do, line 191 */
-        {   int ret = r_other_endings(z);
-            if (ret == 0) goto lab4; /* call other_endings, line 191 */
+    {   int m5 = z->l - z->c; (void)m5; /* do, line 192 */
+        {   int ret = r_other_endings(z); /* call other_endings, line 192 */
+            if (ret == 0) goto lab4;
             if (ret < 0) return ret;
         }
     lab4:
         z->c = z->l - m5;
     }
-    {   int m6 = z->l - z->c; (void)m6; /* or, line 192 */
-        if (!(z->B[0])) goto lab6; /* Boolean test ending_removed, line 192 */
-        {   int m7 = z->l - z->c; (void)m7; /* do, line 192 */
-            {   int ret = r_i_plural(z);
-                if (ret == 0) goto lab7; /* call i_plural, line 192 */
-                if (ret < 0) return ret;
-            }
-        lab7:
-            z->c = z->l - m7;
+    /* or, line 193 */
+    if (!(z->B[0])) goto lab6; /* Boolean test ending_removed, line 193 */
+    {   int m6 = z->l - z->c; (void)m6; /* do, line 193 */
+        {   int ret = r_i_plural(z); /* call i_plural, line 193 */
+            if (ret == 0) goto lab7;
+            if (ret < 0) return ret;
         }
-        goto lab5;
-    lab6:
+    lab7:
         z->c = z->l - m6;
-        {   int m8 = z->l - z->c; (void)m8; /* do, line 192 */
-            {   int ret = r_t_plural(z);
-                if (ret == 0) goto lab8; /* call t_plural, line 192 */
-                if (ret < 0) return ret;
-            }
-        lab8:
-            z->c = z->l - m8;
+    }
+    goto lab5;
+lab6:
+    {   int m7 = z->l - z->c; (void)m7; /* do, line 193 */
+        {   int ret = r_t_plural(z); /* call t_plural, line 193 */
+            if (ret == 0) goto lab8;
+            if (ret < 0) return ret;
         }
+    lab8:
+        z->c = z->l - m7;
     }
 lab5:
-    {   int m9 = z->l - z->c; (void)m9; /* do, line 193 */
-        {   int ret = r_tidy(z);
-            if (ret == 0) goto lab9; /* call tidy, line 193 */
+    {   int m8 = z->l - z->c; (void)m8; /* do, line 194 */
+        {   int ret = r_tidy(z); /* call tidy, line 194 */
+            if (ret == 0) goto lab9;
             if (ret < 0) return ret;
         }
     lab9:
-        z->c = z->l - m9;
+        z->c = z->l - m8;
     }
     z->c = z->lb;
     return 1;
